#! /usr/bin/env python2
# coding: Utf-8

import os, sys, gtk, pango, urllib
datafile = "/tmp/UnicodeData.csv"

def insert(text):
    if len(text) == 0:
        return # Ou pas.
    if not text.startswith(" "):
        text = " "+text #FIXME
    text = text.replace('"', '\\"')
    os.execvp("python", ["python", "-c", 'import pyatspi; pyatspi.Registry()'
        +'.generateKeyboardEvent(0, """'+text+'""", pyatspi.KEY_STRING)'])

def overlay(text, uchar):
    if len(text) == 0: return ""
    if not text.startswith(" "):
        text = " "+text
    return uchar.join(text) 

def acquire(proposed="", icon=None):
    if len(proposed) > 0: return proposed
    text = gtk.clipboard_get("PRIMARY").wait_for_text()
    if text is None: # Rien ici, on demande ?
        if icon is None: return ""
        else: return prompt("", icon)
    else: return text

def _spin_apply(spin, for_dialog):
    text = spin.get_text()
    if text.startswith("0x"):
        text = text[2:]
    elif text.startswith("#"):
        text = text[1:]
    if for_dialog and text == "": # Fini.
        spin.parent.parent.response(gtk.RESPONSE_OK)
    try: # Voyons si ça passe…
        spin.set_value(int(text, 16))
        if for_dialog: # On ajoute le caractère demandé.
            spin.parent.get_children()[-1].append_text(unichr(int(text, 16)))
            gtk.timeout_add(10, spin.set_text, "0x")
        else: gtk.timeout_add(10, spin.set_text, "0x"+text)
    except ValueError: # Bon, valeur pas valide.
        gtk.timeout_add(10, spin.set_text, "0x")
    gtk.timeout_add(10, spin.set_position, -1)

def hexfield(for_dialog=False):
    spin = gtk.SpinButton(gtk.Adjustment(32, 32, 0x110000, 1, 1))
    hexshow = lambda *args: spin.set_text(hex(spin.get_value_as_int()))
    spin.connect("activate", _spin_apply, for_dialog)
    spin.connect_after("value-changed", hexshow)
    spin.connect_after("change-value", hexshow)
    gtk.timeout_add(10, spin.set_position, -1)
    spin.prepend_text("0x")
    return spin

def prompt(text, icon="insert-text", widget=None):
    dialog = gtk.Dialog("⎀") # Pas besoin de titre.
    dialog.connect("focus-out-event", lambda *args:
        dialog.response(gtk.RESPONSE_REJECT))
    dialog.set_keep_above(True)
    dialog.set_decorated(False)
    dialog.set_resizable(False)
    entry = gtk.Entry()
    entry.set_text(" ".join(text.splitlines()))
    entry.set_icon_from_icon_name(gtk.ENTRY_ICON_PRIMARY, icon)
    entry.set_icon_from_icon_name(gtk.ENTRY_ICON_SECONDARY, "go-jump")
    accept = lambda *args: dialog.response(gtk.RESPONSE_OK)
    entry.connect("activate", accept)
    entry.connect("icon-press", accept)
    for child in dialog.vbox.get_children():
        dialog.vbox.remove(child) # Pas la peine.
    if widget is not None: # Ah, donc un autre…
        dialog.vbox.pack_start(widget, True, True)
    dialog.vbox.pack_end(entry, False, False)
    dialog.vbox.show_all() # Pour la taille.
    root = gtk.gdk.get_default_root_window()
    sw,sh = root.get_size()
    x,y,mask = root.get_pointer()
    w,h = dialog.size_request()
    dialog.move(max(0, min(x-w/2, sw-w)), max(0, min(y-h/2, sh-h)))
    dialog.show_all() # C'est parti !
    if dialog.run() == gtk.RESPONSE_OK:
        result = entry.get_text()
    else: result = ""
    dialog.destroy()
    return result

def _prepare(scroll, characters):
    tview = scroll.get_child()
    entry = scroll.parent.get_children()[-1]
    entry.connect("changed", _filter, tview)
    _filter(entry, tview)
    entry.grab_focus()

def _filter(entry, tview):
    store = tview.get_model()
    text = entry.get_text().upper().split()
    store.clear() # On réinitialise…
    if len(text) == 0: return
    for k,v in characters.items():
        candidate = True
        for elem in text:
            if elem not in k:
                candidate = False
                break # C'est bon.
        if candidate: # Ah, une piste.
            store.append([unichr(int(v, 16)), k.lower()])

def _select(tview, path, tvc):
    entry = tview.parent.parent.get_children()[-1]
    entry.set_text(tview.get_model()[path][1])
    entry.activate()

if len(sys.argv) != 2:
    sys.stderr.write("Usage: "+sys.argv[0]+" option\n")
    sys.exit(1)
option,s,value = sys.argv[1].lstrip("-").partition("=")
if option == "hexcode":
    insert(prompt("", "insert-text", hexfield(True)))
elif option == "underline":
    insert(overlay(acquire(value, "format-text-underline"), "̲"))
elif option == "strike":
    insert(overlay(acquire(value, "format-text-strikethrough"), "̶"))
elif option == "search":
    characters = {} # Récupérons la liste…
    if os.path.exists(datafile):
        with open(datafile) as data:
            for line in data: # On récupère directement le cache…
                characters.setdefault(*line.split(";")[1::-1])
    else: # Dans ce cas, il on récupère et on enregistre…
        f = urllib.urlopen("ftp://ftp.unicode.org/"
            + "Public/UNIDATA/UnicodeData.txt")
        g = open(datafile, "w")
        for line in f.readlines():
            g.write(line) # On met ça en cache pour après.
            characters.setdefault(*line.split(";")[1::-1])
        f.close(); g.close()
    # Okay, recherchons ça.
    model = gtk.ListStore(str, str)
    tview = gtk.TreeView(model)
    tview.connect("row-activated", _select)
    tview.set_headers_visible(False)
    tvc = gtk.TreeViewColumn(None)
    cell = gtk.CellRendererText()
    tvc.pack_start(cell, True)
    tvc.add_attribute(cell, 'text', 0)
    tview.append_column(tvc)
    tvc = gtk.TreeViewColumn(None)
    cell = gtk.CellRendererText()
    tvc.pack_start(cell, True)
    tvc.add_attribute(cell, 'text', 1)
    tview.append_column(tvc)
    scroll = gtk.ScrolledWindow()
    scroll.add(tview)
    scroll.set_size_request(312, 180)
    scroll.connect("realize", _prepare, characters)
    scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    desc = prompt(acquire(value), "search", scroll).upper()
    if desc in characters.keys(): # Ah, trouvé.
        insert(unichr(int(characters[desc], 16)))
    elif len(model) == 1: insert(model[0][0])
else: # Ah, bon, bah tant pis.
    sys.stderr.write("Unknown option "+sys.argv[1])
    sys.exit(1)
